<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MotivosIsencaoIvaERP StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:MotivosIsencaoIvaERP
 * @subpackage Structs
 */
class MotivosIsencaoIvaERP extends AbstractStructBase
{
    /**
     * The CodigoMotivoIsencao
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CodigoMotivoIsencao;
    /**
     * The Descricao
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Descricao;
    /**
     * The Protegida
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Protegida;
    /**
     * Constructor method for MotivosIsencaoIvaERP
     * @uses MotivosIsencaoIvaERP::setCodigoMotivoIsencao()
     * @uses MotivosIsencaoIvaERP::setDescricao()
     * @uses MotivosIsencaoIvaERP::setProtegida()
     * @param string $codigoMotivoIsencao
     * @param string $descricao
     * @param bool $protegida
     */
    public function __construct($codigoMotivoIsencao = null, $descricao = null, $protegida = null)
    {
        $this
            ->setCodigoMotivoIsencao($codigoMotivoIsencao)
            ->setDescricao($descricao)
            ->setProtegida($protegida);
    }
    /**
     * Get CodigoMotivoIsencao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodigoMotivoIsencao()
    {
        return isset($this->CodigoMotivoIsencao) ? $this->CodigoMotivoIsencao : null;
    }
    /**
     * Set CodigoMotivoIsencao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codigoMotivoIsencao
     * @return \StructType\MotivosIsencaoIvaERP
     */
    public function setCodigoMotivoIsencao($codigoMotivoIsencao = null)
    {
        // validation for constraint: string
        if (!is_null($codigoMotivoIsencao) && !is_string($codigoMotivoIsencao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codigoMotivoIsencao)), __LINE__);
        }
        if (is_null($codigoMotivoIsencao) || (is_array($codigoMotivoIsencao) && empty($codigoMotivoIsencao))) {
            unset($this->CodigoMotivoIsencao);
        } else {
            $this->CodigoMotivoIsencao = $codigoMotivoIsencao;
        }
        return $this;
    }
    /**
     * Get Descricao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescricao()
    {
        return isset($this->Descricao) ? $this->Descricao : null;
    }
    /**
     * Set Descricao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $descricao
     * @return \StructType\MotivosIsencaoIvaERP
     */
    public function setDescricao($descricao = null)
    {
        // validation for constraint: string
        if (!is_null($descricao) && !is_string($descricao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($descricao)), __LINE__);
        }
        if (is_null($descricao) || (is_array($descricao) && empty($descricao))) {
            unset($this->Descricao);
        } else {
            $this->Descricao = $descricao;
        }
        return $this;
    }
    /**
     * Get Protegida value
     * @return bool|null
     */
    public function getProtegida()
    {
        return $this->Protegida;
    }
    /**
     * Set Protegida value
     * @param bool $protegida
     * @return \StructType\MotivosIsencaoIvaERP
     */
    public function setProtegida($protegida = null)
    {
        // validation for constraint: boolean
        if (!is_null($protegida) && !is_bool($protegida)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($protegida)), __LINE__);
        }
        $this->Protegida = $protegida;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MotivosIsencaoIvaERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
